Index: kernel/zaptel-base.c
===================================================================
--- kernel/zaptel-base.c	(revision 3949)
+++ kernel/zaptel-base.c	(working copy)
@@ -2397,6 +2397,17 @@
 					MOD_INC_USE_COUNT;
 #endif					
 				chans[unit]->flags |= ZT_FLAG_OPEN;
+				/*
+				 * This should really be handled by chan_zap:
+				 *   - After open() it calls ZT_SPANSTAT ioctl
+				 *   - If there are alarms, than inalarm
+				 *     in zt_pvt should be set to true.
+				 * When this is done, we can remove the following code.
+				 */
+				if(chans[unit]->chan_alarms) {
+					/* printk(KERN_NOTICE "Alarms on channel %d\n", unit); */
+					zt_qevent_nolock(chans[unit], ZT_EVENT_ALARM);
+				}
 				spin_unlock_irqrestore(&chans[unit]->lock, flags);
 			} else {
 				spin_unlock_irqrestore(&chans[unit]->lock, flags);
